QGIS Application - Bug report #4011
Map canvas flickers when content is dragged
2011-06-22 03:34 AM - jekhor -

Status: Closed

Priority: Normal

Assignee:

Category: Map Canvas

Affected QGIS version:2.2.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: wontfix
Crashes QGIS or corrupls data: Copied to github as #: 13998
Description

Map canvas flickers when content is dragged. This issue caused by commit:f4d26d6211830a866030a333236dcfbf15e077aa "Fix for
resize crash, ticket #2714". This fix seems dirty :)

This issue is reproduced in 1.7.0 also.

Related issues:
Related to QGIS Application - Bug report # 5008: Map canvas flicker when qgis... Closed 2012-02-14

History

#1 - 2011-08-29 10:41 PM - Paolo Cavallini

- Pull Request or Patch supplied set to No

- Category set to Map Canvas

#2 - 2011-10-26 08:31 PM - sowelu -

Just wanted to update this issue as it is still a big problem on Ubuntu. The MapCanvas still flickers constantly as the map is panned. It also constantly
flickers in the 'dirty' rectangle while creating or editing shapes. The flicker is bad enough that QGIS is not usable for editing vectors. The problem is
apparent in the master version (27/0Oct/2011) and also in the final_1-7-1 tag, built on Kubuntu 11.10. The flickering is not apparent if you check out the

commit before the one indicated above.

Roland

#3 - 2011-10-28 05:42 AM - Tim Sutton

| can replicate on ubuntu 11.10 running xfce4

see

http://www.youtube.com/watch?v=w3x021xXxel

#4 - 2011-10-28 05:46 AM - Giovanni Manghi

| see it too... but | am almost sure that until a few days ago (qgis master on Ubuntu) it wasn't doing it.

Tim Sutton wrote:

I can replicate on ubuntu 11.10 running xfce4
http://www.youtube.com/watch?v=w3xO21xXxeI

see

http.//www.youtube.com/watch ?v=w3x021xXxel

#5 - 2011-12-05 06:25 AM - Alexander Bruy

See also #3771

#6 - 2011-12-16 02:12 PM - Giovanni Manghi

- Target version set to Version 1.7.4

#7 - 2012-02-14 01:27 AM - Gabriele Monfardini

- Affected QGIS version set to master

- Crashes QGIS or corrupts data set to No

Confirmed on ubuntu 11.10 running kde on qgis master commit:2cea349 (20120214)

#8 - 2012-03-11 01:20 AM - jekhor -
- Status changed from Open to Closed
- Resolution set to fixed

Seems be fixed in current master (91da6af5acf4ea09218a495a1ea85dcOccae267e).

#9 - 2012-03-11 01:34 AM - jekhor -
- Status changed from Closed to Reopened
- Resolution deleted (fixed)

Reopen bug, because | didn't found any fixes in code. Probably bug is not reproduced only at my system. Confirmations?

#10 - 2012-03-14 10:58 AM - Giovanni Manghi

- OS version deleted (unstable)

- Status changed from Reopened to Feedback

- Target version changed from Version 1.7.4 to 35
- Operating System deleted (Debian)

jekhor - wrote:

Reopen bug, because | didn't found any fixes in code. Probably bug is not reproduced only at my system. Confirmations?

| update qgis master daily and since the bug surfaced it never went away for me. Anyone else?
http://www.youtube.com/watch?v=w3xO21xXxeI

#11 - 2012-04-12 01:30 AM - Filipe Dias

- File Rendering_shp.7z added

Im adding a video comparing the rendering between QGIS, SAGA GIS and Udig.

| think the rendering in Udig is by far the more "confortable" to the eye, because it doesnt redraw everything, everytime "Pan" is used. SAGA GIS has an
intermediate performance and it redraws the canvas a little faster than QGIS.

#12 - 2012-04-15 10:00 AM - Giovanni Manghi

- Target version changed from 35 to Version 1.8.0

#13 - 2012-04-18 04:22 AM - Giovanni Manghi
- Priority changed from Normal to High

#14 - 2012-05-18 01:25 AM - Matthias Kuhn

| reverted patch commit:f4d26d6211830a866030a333236dcfbf15e077aa and the flicker disappeared. (This makes sense, as this patch disabled
back-buffering)

| then tried to reproduce bug #2714 but QGis wouldn't crash (Qt version 4.8.1). Maybe this issue is solved in gt meanwhile?

#15 - 2012-05-21 05:42 AM - Giovanni Manghi

Matthias Kuhn wrote:

| reverted patch commit:f4d26d6211830a866030a333236dcfbf15e077aa and the flicker disappeared. (This makes sense, as this patch disabled
back-buffering)

I then tried to reproduce bug #2714 but QGis wouldn't crash (Qt version 4.8.1). Maybe this issue is solved in gt meanwhile?

Can anyone of the main developers leave feedback on this? If we can get rid of flickering it would be great... Thanks.

#16 - 2012-05-21 03:20 PM - Martin Dobias

It would be helpful to find out which versions of Qt produce the crashed from #2714 - for those ones the workaround could be kept (checking qVersion) and

for the rest there would be flicker-free dragging.

#17 - 2012-05-27 03:36 PM - Giovanni Manghi

Martin Dobias wrote:

It would be helpful to find out which versions of Qt produce the crashed from #2714 - for those ones the workaround could be kept (checking
qVersion) and for the rest there would be flicker-free dragging.

can anyone help give an answer to Martin question?
#18 - 2012-06-18 12:30 PM - Pedro Venancio

| also have this problem, both in Debian squeeze, wheezy, Xubuntu and Lubuntu 12.04, and on different machines.

| leave here another screencast that shows the problem - http:/goo.gl/lURAVh

QGIS1.7.4and 1.8.

#19 - 2012-07-27 03:42 AM - Matthias Kuhn

Looking at Marcos update for Issue #2714 it could be reproduced with at least Qt 4.6.2 and 4.7.

Regarding the fact that upcoming releases probably only in very rare cases will run with affected Qt versions I'd propose to use this fix with a pre-compiler

switch. This would prevent the (admittedly small) overhead of asking the Qt version on every repaint. A warning could be thrown if one tries to compile on a

system with [Qt < 4.8 && OS != Linux] without the fix.

#20 - 2012-07-27 03:44 AM - Giovanni Manghi

Matthias Kuhn wrote:

Looking at Marcos update for Issue #2714 it could be reproduced with at least Qt 4.6.2 and 4.7.

Regarding the fact that upcoming releases probably only in very rare cases will run with affected Qt versions I'd propose to use this fix with a

pre-compiler switch. This would prevent the (admittedly small) overhead of asking the Qt version on every repaint. A warning could be thrown if one
tries to compile on a system with [Qt < 4.8 && OS != Linux] without the fix.

please raise this issue/discussion/proposal in the developer mailing list. It is a pretty serious issue and nobody seems to care much.

#21 - 2012-07-27 05:27 AM - Jiirgen Fischer

Qt 4.8.1 is also still affected (see ![Qgis-developer] Map canvas flickers)

#22 - 2012-08-02 03:57 AM - Giovanni Manghi

- Target version changed from Version 1.8.0 to Version 2.0.0

- Pull Request or Patch supplied changed from No to Yes

There is a new patch here

http://lists.osgeo.org/pipermail/ggis-developer/2012-August/021444.html

#23 - 2012-08-07 05:32 AM - Giovanni Manghi

Anyone affected by this issue please give a try to this fork/branch

https://github.com/matthias-kuhn/Quantum-GlS/tree/release-1_8
http://goo.gl/URAVh
http://lists.osgeo.org/pipermail/qgis-developer/2012-July/021340.html
it includes a patch that adds an option to enable/disable backbuffer.

#24 - 2012-08-10 12:43 AM - Matthias Kuhn

Fixed on master

New config option in Settings=>Options=>Rendering=>Enable backbuffer
(Only X11 / Linux )

If enabled, drawing is flickerfree, but rendering can't be cancelled (by clicking esc and no incremental feature drawing is possible)
A good fix will be available as soon as threading branch is merged

commit:487879df520e74fed0e0cd06a909b6025ae00c43

#25 - 2012-08-10 01:26 AM - Giovanni Manghi

- Resolution set to fixed

- Status changed from Feedback to Closed

#26 - 2012-08-31 12:44 AM - Alexander Bruy

- Resolution deleted (fixed)

- Status changed from Closed to Reopened
Fix from commit:487879df52 introduces another problem. When backbuffer enabled and layers loaded into map then any docked windows like
Messagelog or SEXTANTE toolbox are opened with artifacts, e.g. some GUI elements are not rendered. To reproduce:

1. enable backbuffer

2. load any wms layer
3. open Messagelog

#27 - 2012-12-30 09:51 AM - Giovanni Manghi

- Priority changed from High to Normal

#28 - 2013-07-08 02:45 PM - Jigdo Stunk

Hello,

| am using the QGIS 1.8 debian wheezy build from 'http://qgis.org/debian/ wheezy main' repository, the flickering bug remains on Debian Wheezy stable
using KDE, and there is no 'enable backbuffer' option at all anywhere in the settings that | can find.

| would have reported this problem a few months ago but instead began using the 1.9 nightly builds until the dependencies broke over the weekend (not

complaining about this -- it is a nightly after all). That coupled with some other problems in 1.9 makes it necessary to use 1.8, but the flicker is so

pronounced it is unusable.

Thank you.

#29 - 2013-07-09 12:30 AM - Giovanni Manghi
- Status changed from Reopened to Feedback
Alexander Bruy wrote:
Fix from commit:487879df52 introduces another problem. When backbuffer enabled and layers loaded into map then any docked windows like
Messagelog or SEXTANTE toolbox are opened with artifacts, e.g. some GUI elements are not rendered. To reproduce:
1. enable backbuffer

2. load any wms layer
3. open MessagelLog

does not happen here/anymore, can you check again?

#30 - 2013-07-09 12:31 AM - Giovanni Manghi

there is no ‘enable backbuffer' option at all anywhere in the settings that | can find.

there are no backports.

#31 - 2013-07-13 01:11 PM - Donovan Cameron

I got the flickering to go away in KDE by changing some settings in System Settings > Qt Graphics System > Configure the default graphics system
of Qt appliations > Default (X11/XRender)

It was set to Raster before - switching to X11/XRender might help for users on KDE for now.

Everything renders smooth now, no flickers for my KDE desktops anymore.

#32 - 2013-07-20 07:24 AM - Daniel Vaz
Giovanni Manghi wrote:
Alexander Bruy wrote:
Fix from commit:487879df52 introduces another problem. When backbuffer enabled and layers loaded into map then any docked windows like
MessagelLog or SEXTANTE toolbox are opened with artifacts, e.g. some GUI elements are not rendered. To reproduce:
1. enable backbuffer
2. load any wms layer

3. open MessagelLog

does not happen here/anymore, can you check again?

If we can't reproduce it, | think that we can close this issue.

If it's reproducible, | think that will be a good idea close this issue and open a new ticket, citing this one.

#33 - 2013-07-25 04:53 PM - Daniel Vaz
- Status changed from Feedback to Closed
Fixed on master. See thread above.

Reopen if necessary.

#34 - 2013-08-28 04:52 AM - Matthias Kuhn

Good catch! Thank you very much.

The easiest thing is to start with the environment variable QT_GRAPHICSSYSTEM=X11, so it leaves the rest of your system untouched.
I'm acutally considering a last-minute patch to remove the "Enable Backbuffer" option and instead use QApplication::setGraphicsSystem().
Will do some in-depth testing on that.

Donovan Cameron wrote:

I got the flickering to go away in KDE by changing some settings in System Settings > Qt Graphics System > Configure the default graphics
system of Qt appliations > Default (X11/XRender)

It was set to Raster before - switching to X11/XRender might help for users on KDE for now.

Everything renders smooth now, no flickers for my KDE desktops anymore.

#35 - 2014-02-25 09:49 AM - Donovan Cameron

- Status changed from Closed to Reopened

Looks like this reared its ugly head in 2.2 and isn't a part of the desktop file anymore. Is it going to be included or is it recommended for package

maintainers to append it on their own?

The new option I've tested on linux (KDE specifically):
"env QT_GRAPHICSSYSTEM=native /usr/bin/qgis"

The Arch Wiki explains that there is no longer an X11 option, instead users can use "native" which is the same as X11.

https://wiki.archlinux.org/index.php/KDE#The _Raster_engine_workaround

#36 - 2014-03-01 03:49 AM - Giovanni Manghi
- Affected QGIS version changed from master to 2.2.0
- Status changed from Reopened to Feedback
- Target version changed from Version 2.0.0 to Version 2.4
Donovan Cameron wrote:
Looks like this reared its ugly head in 2.2 and isn't a part of the desktop file anymore. Is it going to be included or is it recommended for package

maintainers to append it on their own?

on what platform are you seeing this? also on master?
#37 - 2014-03-01 08:27 AM - Jiirgen Fischer

- Target version changed from Version 2.4 to Future Release - High Priority

#38 - 2014-03-16 12:47 PM - Donovan Cameron

Giovanni Manghi wrote:

on what platform are you seeing this? also on master?
This is on QGIS 2.2, | haven't been able to test on master.
Do you think this is specific to desktops running KDE?
$ uname -a

Linux archasus 3.13.6-1-ARCH #1 SMP PREEMPT Fri Mar 7 22:47:48 CET 2014 x86_64 GNU/Linux

#39 - 2014-03-16 04:49 PM - Giovanni Manghi

Do you think this is specific to desktops running KDE?

cannot see it on Mint using Cinnamon or Mate.

#40 - 2014-06-21 02:04 PM - Giovanni Manghi
- Status changed from Feedback to Closed

- Resolution set to wontfix

closing for lack of feedback and because with multithreading this should not be an issue anymore anyway.

Files

Rendering_shp.7z 1.43 MB 2012-04-11 Filipe Dias
